package com.virjar.g4proxy_new.server;

import com.virjar.g4proxy_new.protocol.Constant;
import com.virjar.g4proxy_new.protocol.NatMessage;

import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.timeout.IdleStateEvent;
import io.netty.handler.timeout.IdleStateHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class ServerIdleCheckHandler extends IdleStateHandler {
    public ServerIdleCheckHandler() {
        super(Constant.READ_IDLE_TIME + 10, 0, 0);
    }

    @Override
    protected void channelIdle(ChannelHandlerContext ctx, IdleStateEvent evt) throws Exception {
        if (IdleStateEvent.FIRST_READER_IDLE_STATE_EVENT == evt) {
            log.info("read timeout,close channel");
            ctx.channel().close();
        }
        super.channelIdle(ctx, evt);
    }
}
